#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels

#define OLED_RESET     4 // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3C ///< See datasheet for Address; 0x3D for 128x64, 0x3C for 128x32
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

const int hall = 1;
double tiempo1;
double tiempo2;
double tiempo3;
int tiempo4;
double diferenciatiempo;
int mode = 0;
int interrupcion;
int interrupcion2;
int texto;
int modotexto = 0;
int pulsador=6;
int vuelta = 0;
int vueltatotal = 0;

void setup()
{
  pinMode(pulsador, INPUT_PULLUP);
  pinMode(hall, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(hall), iman, RISING);
  modotexto = digitalRead(pulsador);
  if (HIGH == modotexto) {
    texto = 1;
  }
  else {
    texto = 2;
  }
  display.begin();
  if (texto == 1) {
    display.clearDisplay();
    display.setTextSize(5);             // Normal 1:1 pixel scale
    display.setTextColor(SSD1306_WHITE);        // Draw white text
    display.setCursor(0, 0);
    display.println("0");
    display.setTextSize(2);             // Normal 1:1 pixel scale
    display.setTextColor(SSD1306_WHITE);        // Draw white text
    display.setCursor(90, 12);
    display.println(F("Rpm"));
    display.display();
  }
  else {
    display.clearDisplay();
    display.setTextSize(2);             // Normal 1:1 pixel scale
    display.setTextColor(SSD1306_WHITE);        // Draw white text
    display.setCursor(0, 0);
    display.println(0);
    display.setTextSize(2);             // Normal 1:1 pixel scale
    display.setTextColor(SSD1306_WHITE);        // Draw white text
    display.setCursor(80, 0);
    display.println("Rpm");
    display.setTextSize(2);             // Normal 1:1 pixel scale
    display.setTextColor(SSD1306_WHITE);        // Draw white text
    display.setCursor(0, 19);
    display.println(0);
    display.setTextSize(2);             // Normal 1:1 pixel scale
    display.setTextColor(SSD1306_WHITE);        // Draw white text
    display.setCursor(80, 19);
    display.println("Km");
    display.display();
  }
}

void loop() {

  if (interrupcion != interrupcion2) {
    interrupcion = interrupcion2;
    mode++;

    if (mode == 1) {
      tiempo1 = millis();
    }
    if (mode == 2) {
        modotexto = digitalRead(pulsador);
        if (HIGH == modotexto) {
        texto = 1;
        }
        else {
        texto = 2;
        }
      tiempo2 = millis();
      diferenciatiempo = tiempo2 - tiempo1;
      tiempo3 = 1000 / diferenciatiempo;
      tiempo4 = tiempo3 * 60;
      vuelta++;
      vueltatotal = vuelta * 2.75 * (2 * 3.14 * 0.25); //cambia 0.25 por el radio de la bici y el 2.75 por el total de vueltas de la rueda al dar una pedalada completa
      if (texto == 1) {
        if (diferenciatiempo > 1500) {
          display.clearDisplay();
          display.setTextSize(5);             
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(0, 0);
          display.println("0");
          display.setTextSize(2);             
          display.setTextColor(SSD1306_WHITE);     
          display.setCursor(90, 12);
          display.println("Rpm");
          display.display();
        }
        else {
          display.clearDisplay();
          display.setTextSize(5);          
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(0, 0);
          display.println(tiempo4);
          display.setTextSize(2);          
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(90, 12);
          display.println("Rpm");
          display.display();
        }
      }
      else {
        if (diferenciatiempo > 1500) {
          display.clearDisplay();
          display.setTextSize(2);            
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(0, 0);
          display.println("0");
          display.setTextSize(2);            
          display.setTextColor(SSD1306_WHITE);       
          display.setCursor(80, 0);
          display.println("Rpm");
          display.setTextSize(2);          
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(0, 19);
          display.println(vueltatotal);
          display.setTextSize(2);            
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(80, 19);
          display.println("Km");
          display.display();
        }
        else {
          display.clearDisplay();
          display.setTextSize(2);            
          display.setTextColor(SSD1306_WHITE);        
          display.setCursor(0, 0);
          display.println(tiempo4);
          display.setTextSize(2);            
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(80, 0);
          display.println("Rpm");
          display.setTextSize(2);             
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(0, 19);
          display.println(vueltatotal);
          display.setTextSize(2);             
          display.setTextColor(SSD1306_WHITE);      
          display.setCursor(80, 19);
          display.println("Km");
          display.display();
        }
      }
      tiempo1 = millis();
      mode = 1;
      interrupcion = 0;
    }
  }
  if (interrupcion > 2) {
    interrupcion = 0;
  }
  if (mode > 2) {
    mode = 0;
  }
}
void iman() {
  interrupcion++;
}
